Subject: PropertyMapper throws unnecessary exception
Description

In the case of models with non-optional constructor arguments, you get an exception when one of those subproperties has an error in
the TypeConverter. This can be fixed by changing the following (\TYPO3\FLOW3\Property\PropertyMapper:162)

            $currentPropertyPath[] = $targetPropertyName;
            $targetPropertyValue = $this->doMapping($sourcePropertyValue, $targetPropertyType, $subConfiguration,
$currentPropertyPath);
            array_pop($currentPropertyPath);
            if ($targetPropertyValue !== NULL) {
                $convertedChildProperties[$targetPropertyName] = $targetPropertyValue;
            }

To the following:

            $currentPropertyPath[] = $targetPropertyName;
            $targetPropertyValue = $this->doMapping($sourcePropertyValue, $targetPropertyType, $subConfiguration,
$currentPropertyPath);
            if ($this->messages->forProperty(implode('.', $currentPropertyPath))->hasErrors()) {
                return NULL;
            }
            array_pop($currentPropertyPath);
            if ($targetPropertyValue !== NULL) {
                $convertedChildProperties[$targetPropertyName] = $targetPropertyValue;
            }

History
#1 - 2012-02-21 12:09 - Kira Backes
- Project changed from TYPO3 Flow Base Distribution to TYPO3.Flow

#2 - 2012-02-21 13:56 - Kira Backes

Here is a better solution so you can still get all errors for all properties and you still won’t get an exception even for a lot of nested problems.

Change this (\TYPO3\FLOW3\Property\PropertyMapper:169):

        $result = $typeConverter->convertFrom($source, $targetType, $convertedChildProperties, $configuration);
To:

        if ($this->messages->forProperty(implode('.', $currentPropertyPath))->hasErrors()) {
            return NULL;
        }
        $result = $typeConverter->convertFrom($source, $targetType, $convertedChildProperties, $configuration);

#3 - 2012-03-06 15:12 - Kira Backes

That solution still has a flaw, I can’t see all validation errors no more, because the object validation is missing now.. This seems to be an unsolvable
problem with the current system.

#4 - 2012-03-07 17:22 - Karsten Dambekalns
- Category set to Property
- Has patch set to Yes

#5 - 2012-03-13 12:03 - Christian Müller
- Status changed from New to Needs Feedback

Hi,

could you please try https://review.typo3.org/#/c/9606/ with your environment? I am not sure if that works out but couldn't come up with a good testing
setup.

#6 - 2012-04-27 13:00 - Karsten Dambekalns
- Assigned To set to Christian Müller

#7 - 2014-02-19 10:14 - Bastian Waidelich

Any news on this one?
